import pygame
import random
from pygame import Rect, Surface
#from soultrip.constants import *
#from soultrip.stageobject import StageObject
#from euclid import Vector2
#import Numeric

SYMBOLSIZE = 25
RUNES = [
	0x16A0,
	0x16A1,
	0x16A3,
	0x16A9,
	0x16C3,
	0x16C9,
	0x16D7,
	0x16D2,
	0x16D8,
	0x16E3,
	0x16EF,
	0x16E2,
	0x16EA
]
RUNES += range(0x16A5, 0x16A7)
RUNES += range(0x16AB, 0x16BC)

OTHER = [
	0x0BF5,
	0x13C4,
	0x09E9,
	0x0D39,
	0x214A,
	0x22CB,
	0x25EE,
	0x26B7,
	0x27BF,
	0x2C0F,
	0x046C,
	0x0BA3,
	0x0BF8
]

pygame.font.init()
class Symbol(object):

	rune_font = pygame.font.Font('Junicode.ttf', SYMBOLSIZE)
	
	other_font = pygame.font.Font('FreeSerif.ttf', SYMBOLSIZE)
	
	def __init__(self, color, length = 1):
		self.length = length
		self.letters = []
		self.letters_used = []
		self.color = color


		while len(self.letters) < length:
			rune = random.random() > .5
			if rune:
				letter = unichr(random.choice(RUNES))
				if letter not in self.letters_used:
					self.letters_used.append(letter)
					self.letters.append((0, letter))
			else:
				letter = unichr(random.choice(OTHER))
				if letter not in self.letters_used:
					self.letters_used.append(letter)
					self.letters.append((1, letter))

		
		#print self.letters
		surfs = [self.font_render(x) for x in self.letters]
		#surfs = [pygame.transform.rotate(s, 90) if s.get_width() > s.get_height() else s for s in surfs]
		self.height = int(max(surfs, key = lambda s: s.get_height()).get_height())
		self.width = int(reduce(lambda s1, s2: s1 + s2.get_width(), surfs, 0))
		#self.width -= LETTER_OFFSET * len(self.letters)
		self.extents = (self.width, self.height)
		self.surf_templ = Surface((self.width, self.height)).convert_alpha()
		self.surf = Surface((self.width, self.height)).convert_alpha()
		
		#self.letters = [unichr(random.choice(RUNES)) for x in range(0, length)]
		
	def font_render(self, letter):

		if letter[0] == 0:
			return Symbol.rune_font.render(letter[1], True, self.color)
		else:
			return Symbol.other_font.render(letter[1], True, self.color)
	def render2surf(self):
		surfs = [self.font_render(x) for x in self.letters]
		#surfs = [pygame.transform.rotate(s, 90) if s.get_width() > s.get_height() else s for s in surfs]
		self.surf.fill([255, 255, 255, 0])
		x = 0
		for s in surfs:
			self.surf.blit(s, (x, 0))
			x += s.get_width()

	def get_surf(self):
		self.render2surf()
		s = self.surf_templ.copy()
		s.fill((255, 255, 255, 0))
		s.blit(self.surf, (0, 0))
		return s

	def draw(self, layer, pos):
		s = self.get_surf()
		layer.blit(s, pos)


class ButtonSymbol(Symbol):
	rune_font = pygame.font.Font('Junicode.ttf', 16)
	other_font = pygame.font.Font('FreeSerif.ttf', 16)

	def __init__(self, color, length = 1, letters = []):
		Symbol.__init__(self, color, length, letters)

	def font_render(self, letter):

		if letter[0] == 0:
			return Symbol.rune_font.render(letter[1], True, self.color)
		else:
			return Symbol.other_font.render(letter[1], True, self.color)